// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
//
//          streamCapture2
//          (C) Copyright  2016 - 2024 Ingemar Ceicer
//          https://gitlab.com/posktomten/streamcapture2/
//          programming@ceicer.com
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>

#include "newprg.h"
#include "downloadunpack.h"
void Newprg::getDownloadList(QString *content)
{
    static QRegularExpression qre("[\n]");
    downloadList = content->split(qre, Qt::SkipEmptyParts);
}
void Newprg::getSettings(QString *content)
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME, EXECUTABLE_NAME);
    QString inifile = settings.fileName();
#ifdef Q_OS_WINDOWS
//    QStringList list = content->split("\r\n", Qt::SkipEmptyParts);
    QStringList list = content->split("\r\n", Qt::SkipEmptyParts);
#endif
#ifdef Q_OS_LINUX
    QStringList list = content->split("\n", Qt::SkipEmptyParts);
#endif
    QFile fil(inifile);

    if(fil.open(QIODevice::WriteOnly)) {
        QTextStream in(&fil);

        for(const QString &s : list) {
#ifdef Q_OS_LINUX
            in << s + "\n";
#endif
#ifdef Q_OS_WINDOWS
            in << s + "\r\n";
#endif
        }
    }

    fil.close();
}
void Newprg::getSettingsDownloadunpack(QString *content)
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME, LIBRARY_NAME);
    QString inifile = settings.fileName();
#ifdef Q_OS_WINDOWS
//    QStringList list = content->split("\r\n", Qt::SkipEmptyParts);
    QStringList list = content->split("\r\n", Qt::SkipEmptyParts);
#endif
#ifdef Q_OS_LINUX
    QStringList list = content->split("\n", Qt::SkipEmptyParts);
#endif
    QFile fil(inifile);

    if(fil.open(QIODevice::WriteOnly)) {
        QTextStream in(&fil);

        for(const QString &s : list) {
#ifdef Q_OS_LINUX
            in << s + "\n";
#endif
#ifdef Q_OS_WINDOWS
            in << s + "\r\n";
#endif
        }
    }

    fil.close();
}
void Newprg::getRecentSearches(QString *content)
{
//    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME, EXECUTABLE_NAME);
//    QString inifile = settings.fileName();
//    QFileInfo fi(inifile);
//    QString recentsearches = fi.absolutePath() + "/recentfiles.list";
//    QStringList list = content->split(QRegularExpression("[\n]"), Qt::SkipEmptyParts);
#ifdef Q_OS_WINDOWS
    QStringList list = content->split("\r\n", Qt::SkipEmptyParts);
#endif
#ifdef Q_OS_LINUX
    QStringList list = content->split("\n", Qt::SkipEmptyParts);
#endif
//    QFile fil(recentsearches);
    recentFiles.clear();
//    if(fil.open(QIODevice::WriteOnly)) {
//        QTextStream in(&fil);
#if QT_VERSION > QT_VERSION_CHECK(5, 15, 21)

    for(const QString &s : std::as_const(list)) {
        //            in << s + "\n";
        recentFiles << s;
    }

#else

    for(const QString &s : qAsConst(list)) {
        //            in << s + "\n";
        recentFiles << s;
    }
#endif
//        fil.close();
//    }
}
