// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
//
//          streamCapture2
//          (C) Copyright  2016 - 2024 Ingemar Ceicer
//          https://gitlab.com/posktomten/streamcapture2/
//          programming@ceicer.com
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>

#include "newprg.h"

void Newprg::systemDefaultTheme()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    settings.beginGroup("Settings");
    QString theme = settings.value("theme", "system").toString();
    settings.endGroup();

    if(theme == "system") {
        return;
    }

    QMessageBox *msgBox = new QMessageBox(this);
    QIcon iconYes(QPixmap(":/images/restart.png"));
    QIcon iconLater(QPixmap(":/images/later.png"));
    QIcon iconReject(QPixmap(":/images/exit.png"));
    QPushButton  *yesButton = new QPushButton(iconYes, tr("Restart Now"), msgBox);
    QPushButton  *laterButton = new QPushButton(iconLater, tr("System Default Theme next start"), msgBox);
    QPushButton  *rejectButton = new QPushButton(iconReject, tr("Cancel"), msgBox);
    msgBox->addButton(yesButton, QMessageBox::YesRole);
    msgBox->addButton(laterButton, QMessageBox::YesRole);
    msgBox->addButton(rejectButton, QMessageBox::RejectRole);
    msgBox->setDefaultButton(laterButton);
    msgBox->setWindowTitle(DISPLAY_NAME " " VERSION);
    msgBox->setText(tr("The program must be restarted to switch to System Default Theme."));
    int outpup = msgBox->exec();

    if(outpup == 0)  {
        settings.beginGroup("Settings");
        settings.setValue("theme", "system");
        settings.endGroup();
        settings.sync();
        const QString EXECUTE =
            QCoreApplication::applicationDirPath() + "/" +
            QFileInfo(QCoreApplication::applicationFilePath()).fileName();
        QProcess p;
        p.setProgram(EXECUTE);
        p.startDetached();
        delete msgBox;
        close();
    } else if(outpup == 1) {
        settings.beginGroup("Settings");
        settings.setValue("theme", "system");
        settings.endGroup();
        delete msgBox;
        return;
    } else  if(outpup == 2) {
        delete msgBox;
        return;
    }
}

void Newprg::lightTheme()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    settings.beginGroup("Settings");
    QString theme = settings.value("theme", "system").toString();
    settings.endGroup();

    if(theme == "light") {
        return;
    }

    QMessageBox *msgBox = new QMessageBox(this);
    QIcon iconYes(QPixmap(":/images/restart.png"));
    QIcon iconLater(QPixmap(":/images/later.png"));
    QIcon iconReject(QPixmap(":/images/exit.png"));
    QPushButton  *yesButton = new QPushButton(iconYes, tr("Restart Now"), msgBox);
    QPushButton  *laterButton = new QPushButton(iconLater, tr("Light Theme next start"), msgBox);
    QPushButton  *rejectButton = new QPushButton(iconReject, tr("Cancel"), msgBox);
    msgBox->addButton(yesButton, QMessageBox::YesRole);
    msgBox->addButton(laterButton, QMessageBox::YesRole);
    msgBox->addButton(rejectButton, QMessageBox::RejectRole);
    msgBox->setDefaultButton(laterButton);
    msgBox->setWindowTitle(DISPLAY_NAME " " VERSION);
    msgBox->setText(tr("The program must be restarted to switch to Light Theme."));
    int outpup = msgBox->exec();

    if(outpup == 0)  {
        settings.beginGroup("Settings");
        settings.setValue("theme", "light");
        settings.endGroup();
        settings.sync();
        const QString EXECUTE =
            QCoreApplication::applicationDirPath() + "/" +
            QFileInfo(QCoreApplication::applicationFilePath()).fileName();
        QProcess p;
        p.setProgram(EXECUTE);
        p.startDetached();
        delete msgBox;
        close();
    } else if(outpup == 1) {
        settings.beginGroup("Settings");
        settings.setValue("theme", "light");
        settings.endGroup();
        delete msgBox;
        return;
    } else  if(outpup == 2) {
        delete msgBox;
        return;
    }
}

void Newprg::darkTheme()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    settings.beginGroup("Settings");
    QString theme = settings.value("theme", "system").toString();
    settings.endGroup();

    if(theme == "dark") {
        return;
    }

    QMessageBox *msgBox = new QMessageBox(this);
    QIcon iconYes(QPixmap(":/images/restart.png"));
    QIcon iconLater(QPixmap(":/images/later.png"));
    QIcon iconReject(QPixmap(":/images/exit.png"));
    QPushButton  *yesButton = new QPushButton(iconYes, tr("Restart Now"), msgBox);
    QPushButton  *laterButton = new QPushButton(iconLater, tr("Dark Theme next start"), msgBox);
    QPushButton  *rejectButton = new QPushButton(iconReject, tr("Cancel"), msgBox);
    msgBox->addButton(yesButton, QMessageBox::YesRole);
    msgBox->addButton(laterButton, QMessageBox::YesRole);
    msgBox->addButton(rejectButton, QMessageBox::RejectRole);
    msgBox->setDefaultButton(laterButton);
    msgBox->setWindowTitle(DISPLAY_NAME " " VERSION);
    msgBox->setText(tr("The program must be restarted to switch to Dark Theme."));
    int outpup = msgBox->exec();

    if(outpup == 0)  {
        settings.beginGroup("Settings");
        settings.setValue("theme", "dark");
        settings.endGroup();
        settings.sync();
        const QString EXECUTE =
            QCoreApplication::applicationDirPath() + "/" +
            QFileInfo(QCoreApplication::applicationFilePath()).fileName();
        QProcess p;
        p.setProgram(EXECUTE);
        p.startDetached();
        delete msgBox;
        close();
    } else if(outpup == 1) {
        settings.beginGroup("Settings");
        settings.setValue("theme", "dark");
        settings.endGroup();
        delete msgBox;
        return;
    } else  if(outpup == 2) {
        delete msgBox;
        return;
    }
}
