#include <QtWidgets>
#include <QWheelEvent>

class ZoomDisabler : public QObject
{
    Q_OBJECT

public:
    ZoomDisabler(QObject* parent = nullptr) : QObject(parent)
    {
        // Anslut eventfiltret till applikationsinstansen
        qApp->installEventFilter(this);
    }

    // Eventfiltermetod som interceperar musevent
    bool eventFilter(QObject* obj, QEvent* event) override
    {
        if(event->type() == QEvent::Wheel) {
            // QWheelEvent* wheelEvent = static_cast<QWheelEvent*>(event);

            // Kontrollera om Ctrl-tangenten är nedtryckt
            if(QApplication::keyboardModifiers() & Qt::ControlModifier) {
                // Förhindra zoom genom att konsumera händelsen
                return true;
            }
        }

        // Fortsätt att behandla händelsen normalt
        return QObject::eventFilter(obj, event);
    }
};
